#include "bfd.bi"

#ifdef __FB_DOS__
#define EOL chr(10)
#else
#define EOL chr(13, 10)
#endif

sub ShowType( t as string, s as integer )
  ? t; ": "; str(s); EOL;
end sub

sub ShowMember( t as string, m as string, o as integer )
  open cons for output as #1
  ? "    "; t; "."; m; ": "; str(o); EOL;
  close #1
end sub

#define ST( A )    ShowType( #A, sizeof(A) )
#define SM( A, B ) ShowMember( #A, #B, offsetof( a, b ) )

	ST( carsym )
	SM( carsym, name )
	SM( carsym, file_offset )

	ST( symbol_info )
	SM( symbol_info, value )
	SM( symbol_info, type )
	SM( symbol_info, name )
	SM( symbol_info, stab_type )
	SM( symbol_info, stab_other )
	SM( symbol_info, stab_desc )
	SM( symbol_info, stab_name )

	ST( bfd_hash_entry )
	SM( bfd_hash_entry, next )
	SM( bfd_hash_entry, string )
	SM( bfd_hash_entry, hash )

	ST( bfd_hash_table )
	SM( bfd_hash_table, table )
	SM( bfd_hash_table, size )
	SM( bfd_hash_table, entsize )
	SM( bfd_hash_table, newfunc )
	SM( bfd_hash_table, memory )

	ST( bfd_window )
	SM( bfd_window, data )
	SM( bfd_window, size )
	SM( bfd_window, i )

	ST( coff_comdat_info )
	SM( coff_comdat_info, name )
	SM( coff_comdat_info, symbol )

''	ST( asection_map )
''	SM( asection_map, link_order )
''	SM( asection_map, s )

	ST( bfd_section )
	SM( bfd_section, name )
	SM( bfd_section, id )
	SM( bfd_section, index )
	SM( bfd_section, next )
	SM( bfd_section, prev )
	SM( bfd_section, flags )
/'
	user_set_vma:1 as uinteger
	linker_mark:1 as uinteger
	linker_has_input:1 as uinteger
	gc_mark:1 as uinteger
	gc_mark_from_eh:1 as uinteger
	segment_mark:1 as uinteger
	sec_info_type:3 as uinteger
	use_rela_p:1 as uinteger
	has_tls_reloc:1 as uinteger
	has_gp_reloc:1 as uinteger
	need_finalize_relax:1 as uinteger
	reloc_done:1 as uinteger
'/
	SM( bfd_section, vma )
	SM( bfd_section, lma )
	SM( bfd_section, size )
	SM( bfd_section, rawsize )
	SM( bfd_section, output_offset )
	SM( bfd_section, output_section )
	SM( bfd_section, alignment_power )
	SM( bfd_section, relocation )
	SM( bfd_section, orelocation )
	SM( bfd_section, reloc_count )
	SM( bfd_section, filepos )
	SM( bfd_section, rel_filepos )
	SM( bfd_section, line_filepos )
	SM( bfd_section, userdata )
	SM( bfd_section, contents )
	SM( bfd_section, lineno )
	SM( bfd_section, lineno_count )
	SM( bfd_section, entsize )
	SM( bfd_section, kept_section )
	SM( bfd_section, moving_line_filepos )
	SM( bfd_section, target_index )
	SM( bfd_section, used_by_bfd )
	SM( bfd_section, constructor_chain )
	SM( bfd_section, owner )
	SM( bfd_section, symbol )
	SM( bfd_section, symbol_ptr_ptr )
	SM( bfd_section, map_head )
	SM( bfd_section, map_tail )
